#for unix system
  META_DIR=/home/lavil/meta
  INSTALL_DIR=/home/lavil/outils
#for dos something like this
#META_DIR=\\meta
#INSTALL_DIR=\\djgpp\\bin
#INSTALL_DIR_SKIMMED=\djgpp\bin

# RM=rm
# pour SUN
# MACHFLAGS=-DSUN
# RM_UNIX="rm *.*~ *~ \#*\#" 
# pour SOLARIS
# MACHFLAGS=-DSUN -DSOLARIS
# RM_UNIX="rm *.*~ *~ \#*\#" 
# pour Interactive
# MACHFLAGS=-DSUN -DI386 -D_POSIX_SOURCE -D_SYSV3
# RM_UNIX="rm *.*~ *~ \#*\#" 
# pour LINUX
MACHFLAGS=-DSUN -DLINUX -m486 -pipe
RM_UNIX="rm *.*~ *~ \#*\#"
# pour DOS
#MACHFLAGS=-DSUN -DLINUX -DDOS
#RM_UNIX=@echo on
#LIB_SYS=-lgpp -liostr

#for unix
C_PLUS=g++
#for dos
#C_PLUS=gcc
#C_PLUS_LNK=g++

C_WARNING =  -W -Wimplicit -Wreturn-type -Wswitch \
	   -Wcomment -Wformat -Wchar-subscripts -Wuninitialized 

OPTIM_FLAG=-g

C_FLAGS= $(OPTIM_FLAG) $(C_WARNING)


.SUFFIXES: .ch .cc .C .c .h .o

INCLUDE_DIR= -I$(META_DIR)/pub/library -I$(META_DIR)/pub/parser \
			 -I$(META_DIR)/pub/cplusplu -I$(META_DIR)/pub/chopb \
			 -I$(META_DIR)/pub/metachop -I$(META_DIR)/private/asn \
			 -I$(META_DIR)/private/asnext

.ch.cc:
	$(GO32) $(UTIL_DIR)metachop -c++ $*.ch > $*.cc
.cc.o :
	$(C_PLUS) -c $(MACHFLAGS) $(C_FLAGS) $(INCLUDE_DIR) $(OPT_FLAGS) $*.cc
.c.o :
	gcc -c $(MACHFLAGS) $(C_FLAGS) $(INCLUDE_DIR) $(OPT_FLAGS) $*.c

# mettre -DI386 pour interactive

clean_inc :
	-  $(RM) *.o *.a *.ll res.* *.exe
	-  $(RM) -r compile.dir
	-  $(RM) core
	-  $(RM) res.*
	-  sh -c $(RM_UNIX)

clean_inc_appli : clean_inc
	-  $(RM) *.C *.cc m_done

all_test :
	@- for i in s* ; do \
			 echo $$i ; \
			 $$i > res.$$i 2>&1 ; diff res.$$i ref.$$i ; \
		   done
prof :
	$(MAKE) all "OPTIM_FLAG=-g -pg" -f makefile.uni
optim :
	$(MAKE) all "OPTIM_FLAG=-O2" -f makefile.uni
optimg :
	$(MAKE) all "OPTIM_FLAG=-O2 -g" -f makefile.uni
checker :
	$(MAKE) all "C_PLUS=checkerg++" -f makefile.uni
check :
	$(MAKE) all "OPTIM_FLAG=-g" "INCLUDE_DIR= -I../../dbmalloc -I../library -I../parser -I../cplusplu -I../chopb -I../metachop -I../asn -I../asnext" "LIB_SYS=-ldbmalloc" -f makefile.uni

METAOPT = 
LIBRARY = $(META_DIR)/pub/library/meta.a  $(LIB_SYS)
