#ifndef CHOPB_PARSER
#define CHOPB_PARSER

 extern int nb_par_parse;


#ifdef __cplusplus
#include "cplus.h"
typedef int (pretty::** _FUNC_MEMB_CHOPB) ();
class chopb: public cplus {
    public :
    
    static int init ; 
    
    chopb () {
        ptTokenArray = _tokenArray;
        ptTokenFuncArray =(_FUNC_MEMB_CHOPB) _tokenFuncArray;
        ptTokenNbFuncArray = _tokenNbFuncArray;
        InitConst ();
        inMakeTree = 0 ;
        parse = 0 ;
        or_not_ok = 0 ;
        
    }
    
    virtual void * rootGrammar () { return (void *) this;}
    virtual int Lex() ;
    virtual int LexComment() ;
    virtual int LexEtoiEtoi() ;
    virtual int LexMeta() ;
    virtual int LexParse() ;
    virtual int LexSup() ;
    virtual PPTREE assignment_expression ( int error_free) ;
    virtual PPTREE cast_expression_value ( int error_free) ;
    virtual PPTREE exclusive_or_expression ( int error_free) ;
    virtual PPTREE expression ( int error_free) ;
    virtual int formatBeg() ;
    virtual PPTREE multiplicative_expression ( int error_free) ;
    virtual PPTREE old ( int error_free) ;
    virtual PPTREE postfix_expression ( int error_free) ;
    virtual PPTREE primary_expression ( int error_free) ;
    virtual PPTREE prog ( int error_free) ;
    virtual PPTREE relational_expression ( int error_free) ;
    virtual PPTREE shift_expression ( int error_free) ;
    virtual PPTREE statement ( int error_free) ;
    virtual PPTREE take_follow ( int error_free) ;
    virtual PPTREE take_follow_list ( int error_free) ;
    virtual PPTREE take_follow_super ( int error_free) ;
    
    
    int inMakeTree;
    int parse;
    int or_not_ok;
    static signed char * _tokenArray [138];
    static int (chopb::*(_tokenFuncArray [138])) ();
    static int _tokenNbFuncArray [138];

    virtual int SortKeyWord (int ret);
    virtual int UpSortKeyWord (int ret); 
    virtual void InitConst ();
    
    enum constants {
        NODE_LIST =     338 ,
        NODE_TREE =     337 ,
        SPACE =     336 ,
        SEP_OMIT =  335 ,
        SEP_BEFORE =    334 ,
        SEP_AFTER =     333 ,
        AFERAFER =  332 ,
        ALINEA =    331 ,
        CHOP_DEF =  330 ,
        NIL =   329 ,
        IN_LANG =   328 ,
        NEXT =  327 ,
        DEF_IDENT =     326 ,
        BOX =   325 ,
        EXPO =  324 ,
        EXPO_AFF =  323 ,
        ETOIETOIEGAL =  322 ,
        FOREACH =   321 ,
        INFESEPOSUPE =  320 ,
        INFESEPBSUPE =  319 ,
        INFESEPASUPE =  318 ,
        AOUVAOUV =  317 ,
        ARRO =  316 ,
        IN =    315 ,
        PARSE =     314 ,
        NEXTL =     313 ,
        VALUE =     312 ,
        INFESUPE =  311 ,
        NL_BEG =    310 ,
        TAB_BEG =   309 ,
        SPACE_BEG =     308 ,
        MAKETREE_SUP =  307 ,
        MAKETREE_INF =  306 ,
        PARSE_ELEM =    305 ,
        SIMP_ETOI =     304 ,
        ETOI_ETOI =     303 ,
        BDECR =     302 ,
        BINCR =     301 ,
        ADDR =  300 ,
        NOT =   299 ,
        LNEG =  298 ,
        POS =   297 ,
        NEG =   296 ,
        STRING_LIST =   295 ,
        LABEL =     294 ,
        THROW_ANSI =    293 ,
        ELSE =  292 ,
        TUNSIGNED =     291 ,
        TSIGNED =   290 ,
        TIDENT =    289 ,
        TFLOAT =    288 ,
        TDOUBLE =   287 ,
        RSHI =  286 ,
        LSHI =  285 ,
        LT =    284 ,
        GT =    283 ,
        GEQU =  282 ,
        LEQU =  281 ,
        PROTECT_MEMB =  280 ,
        LANGUAGE =  279 ,
        EXP =   278 ,
        ADECR =     277 ,
        AINCR =     276 ,
        ARROW =     275 ,
        REF =   274 ,
        EXP_ARRAY =     273 ,
        EXP_LIST =  272 ,
        ARROW_MEMB =    271 ,
        DOT_MEMB =  270 ,
        POINETOI =  269 ,
        TIRESUPEETOI =  268 ,
        TIRESUPE =  267 ,
        SUPESUPE =  266 ,
        INFEINFE =  265 ,
        SUPEEGAL =  264 ,
        INFEEGAL =  263 ,
        NEW_DECLARATOR =    262 ,
        REM =   261 ,
        DIV =   260 ,
        MUL =   259 ,
        POURC =     258 ,
        MESSAGE_MAP =   257 ,
        MACRO =     256 ,
        TCHAR =     255 ,
        TSHORT =    254 ,
        TLONG =     253 ,
        TINT =  252 ,
        OR =    251 ,
        VBARVBAR =  250 ,
        AND =   249 ,
        ETCOETCO =  248 ,
        COMPOUND_EXT =  247 ,
        EXTERNAL =  246 ,
        INITIALIZER =   245 ,
        LOR =   244 ,
        VBAR =  243 ,
        FUNC =  242 ,
        STAT_VOID =     241 ,
        TEMPLATE_DECL =     240 ,
        CLASS_PARAM =   239 ,
        EXP_SEQ =   238 ,
        LXOR =  237 ,
        CHAP =  236 ,
        EXCEPTION_ANSI =    235 ,
        EXCEPTION =     234 ,
        NEQU =  233 ,
        EQU =   232 ,
        EXCLEGAL =  231 ,
        EGALEGAL =  230 ,
        PRAGMA =    229 ,
        INDENT_FUNCTION_TYPE =  228 ,
        COMMENT_PLUS =  227 ,
        COMMENT_END =   226 ,
        COMMENT_MIDDLE =    225 ,
        COMMENT_START =     224 ,
        MARGIN_VALUE =  223 ,
        BRACE_ALIGN_VALUE =     222 ,
        ASSIGN_ALIGN =  221 ,
        SINGLE_SWITCH_INDENT_VALUE =    220 ,
        SIMPLIFY_VALUE =    219 ,
        SIMPLIFY =  218 ,
        MODE_VALUE =    217 ,
        TAB_VALUE =     216 ,
        CONFIG =    215 ,
        NO_PRETTY =     214 ,
        ERROR =     213 ,
        UNDEF =     212 ,
        TYP_AFF_CALL =  211 ,
        MEMBER_DECLARATOR =     210 ,
        TYP_ARRAY =     209 ,
        CFER =  208 ,
        COUV =  207 ,
        FOR_DECLARATION =   206 ,
        DECLARATION =   205 ,
        CTOR_INITIALIZER =  204 ,
        CTOR_INIT =     203 ,
        IUN =   202 ,
        IUNLONG =   201 ,
        ILONG =     200 ,
        RANGE_MODIFIER =    199 ,
        COND_AFF =  198 ,
        INTE =  197 ,
        COMPOUND =  196 ,
        PARAM_TYPE =    195 ,
        SUPE =  194 ,
        INFE =  193 ,
        CLASS_DECL =    192 ,
        AFER =  191 ,
        CATCH_ANSI =    190 ,
        EXCEPT_ANSI_ALL =   189 ,
        CAST =  188 ,
        DPOI =  187 ,
        TYP_BIT =   186 ,
        PROTECT =   185 ,
        BASE_LIST =     184 ,
        XOR_AFF =   183 ,
        OR_AFF =    182 ,
        AND_AFF =   181 ,
        RSH_AFF =   180 ,
        LSH_AFF =   179 ,
        MIN_AFF =   178 ,
        PLU_AFF =   177 ,
        REM_AFF =   176 ,
        DIV_AFF =   175 ,
        MUL_AFF =   174 ,
        AFF =   173 ,
        POINPOINPOIN =  172 ,
        VAR_LIST =  171 ,
        TYP_LIST =  170 ,
        TYP_AFF =   169 ,
        ABST_DECLARATOR =   168 ,
        DECLARATOR =    167 ,
        LAND =  166 ,
        INIT_NEW =  165 ,
        VIRG =  164 ,
        QUALIFIED =     163 ,
        MINUS =     162 ,
        TYP =   161 ,
        PFER =  160 ,
        DESTRUCT =  159 ,
        TYP_REF =   158 ,
        TYP_ADDR =  157 ,
        DEFAULT =   156 ,
        CASE =  155 ,
        THROW =     154 ,
        FORALLSONS =    153 ,
        WHILE =     152 ,
        SWITCH =    151 ,
        RETURN =    150 ,
        IF =    149 ,
        FOR =   148 ,
        DO =    147 ,
        CONTINUE =  146 ,
        BREAK =     145 ,
        PVIR =  144 ,
        TYPEDEF =   143 ,
        TEMPLATE =  142 ,
        TRY =   141 ,
        EXTERN =    140 ,
        STATIC =    139 ,
        AUTO =  138 ,
        AOUV =  137 ,
        CATCH =     136 ,
        PUBLIC =    135 ,
        PROTECTED =     134 ,
        PRIVATE =   133 ,
        CHAPEGAL =  132 ,
        VBAREGAL =  131 ,
        ETCOEGAL =  130 ,
        SUPESUPEEGAL =  129 ,
        INFEINFEEGAL =  128 ,
        TIREEGAL =  127 ,
        PLUSEGAL =  126 ,
        POURCEGAL =     125 ,
        ETOIEGAL =  124 ,
        EGAL =  123 ,
        ASM =   122 ,
        CLASS =     121 ,
        UNION =     120 ,
        STRUCT =    119 ,
        ENUM =  118 ,
        CONST =     117 ,
        FRIEND =    116 ,
        VIRTUAL =   115 ,
        INLINE =    114 ,
        REGISTER =  113 ,
        VOLATILE =  112 ,
        SHORT =     111 ,
        UNSIGNED =  110 ,
        SIGNED =    109 ,
        LONG =  108 ,
        VOID =  107 ,
        CHAR =  106 ,
        INT =   105 ,
        DOUBLE =    104 ,
        VA_ARG =    103 ,
        OPERATOR =  102 ,
        DELETE =    101 ,
        NEW =   100 ,
        DPOIDPOI =  99 ,
        SIZEOF =    98 ,
        TIRETIRE =  97 ,
        PLUSPLUS =  96 ,
        ETCO =  95 ,
        ETOI =  94 ,
        EXCL =  93 ,
        TILD =  92 ,
        PLUS =  91 ,
        TIRE =  90 ,
        POUV =  89 ,
        FUNC_SPEC =     88 ,
        TRY_UPPER =     87 ,
        END_CATCH =     86 ,
        END_CATCH_ALL =     85 ,
        AND_CATCH =     84 ,
        CATCH_UPPER =   83 ,
        CATCH_ALL =     82 ,
        END_MESSAGE_MAP =   81 ,
        BEGIN_MESSAGE_MAP =     80 ,
        DECLARE_MESSAGE_MAP =   79 ,
        IMPLEMENT_SERIAL =  78 ,
        IMPLEMENT_DYNCREATE =   77 ,
        IMPLEMENT_DYNAMIC =     76 ,
        DECLARE_SERIAL =    75 ,
        DECLARE_DYNAMIC =   74 ,
        PUSH_FUNCTION =     73 ,
        PUSH_ARGUMENT =     72 ,
        UNDEF_CONTENT =     71 ,
        SMALL_PRAGMA_CONTENT =  70 ,
        PRAGMA_CONTENT =    69 ,
        PRAGMA_INDENT_FUNCTION_TYPE =   68 ,
        PRAGMA_COMMENT_PLUS =   67 ,
        PRAGMA_COMMENT_END =    66 ,
        PRAGMA_COMMENT_MIDDLE =     65 ,
        PRAGMA_COMMENT_START =  64 ,
        PRAGMA_MARGIN =     63 ,
        PRAGMA_ASSIGN_ALIGN =   62 ,
        PRAGMA_SINGLE_SWITCH_INDENT =   61 ,
        PRAGMA_SIMPLIFY =   60 ,
        PRAGMA_BRACE_ALIGN =    59 ,
        PRAGMA_MODE =   58 ,
        PRAGMA_RANGE =  57 ,
        PRAGMA_TAB =    56 ,
        PRAGMA_CONFIG =     55 ,
        PRAGMA_NOPRETTY =   54 ,
        PRAGMA_PRETTY =     53 ,
        INCLUDE_LOCAL =     52 ,
        INCLUDE_SYS =   51 ,
        END_LINE =  50 ,
        DEFINE_NAME =   49 ,
        DEFINED_NOT_CONTINUED =     48 ,
        DEFINED_CONTINUED =     47 ,
        POINT =     46 ,
        SLAS =  45 ,
        SLASEGAL =  44 ,
        CARRIAGE_RETURN =   43 ,
        UNDEF_DIR =     42 ,
        DEFINE_DIR =    41 ,
        ERROR_DIR =     40 ,
        PRAGMA_DIR =    39 ,
        LINE_DIR =  38 ,
        ENDIF_DIR =     37 ,
        ELIF_DIR =  36 ,
        ELSE_DIR =  35 ,
        IF_DIR =    34 ,
        IFNDEF_DIR =    33 ,
        IFDEF_DIR =     32 ,
        INCLUDE_DIR =   31 ,
        OCTAL =     30 ,
        UOCTAL =    29 ,
        LOCTAL =    28 ,
        ULOCTAL =   27 ,
        HEXA =  26 ,
        UHEXA =     25 ,
        LHEXA =     24 ,
        ULHEXA =    23 ,
        INTEGER =   22 ,
        FLOAT =     21 ,
        UINTEGER =  20 ,
        LINTEGER =  19 ,
        ULINTEGER =     18 ,
        CHARACT =   17 ,
        STRING =    16 ,
        IDENT =     15 ,
        GOTO_REL =  14 ,
        GOTO =  13 ,
        STR =   12 ,
        UNMARK =    11 ,
        MARK =  10 ,
        TAB_VIRT =  9 ,
        TAB =   8 ,
        NEWLINE =   7 ,
        ATTRIBUTS =     6 ,
        PLACE_HOLD_CONST
    } ; 
} ; 

extern chopb * parser_chopb;

#endif
#define NODE_LIST_chopb     338
#define NODE_TREE_chopb     337
#define SPACE_chopb     336
#define SEP_OMIT_chopb  335
#define SEP_BEFORE_chopb    334
#define SEP_AFTER_chopb     333
#define AFERAFER_chopb  332
#define ALINEA_chopb    331
#define CHOP_DEF_chopb  330
#define NIL_chopb   329
#define IN_LANG_chopb   328
#define NEXT_chopb  327
#define DEF_IDENT_chopb     326
#define BOX_chopb   325
#define EXPO_chopb  324
#define EXPO_AFF_chopb  323
#define ETOIETOIEGAL_chopb  322
#define FOREACH_chopb   321
#define INFESEPOSUPE_chopb  320
#define INFESEPBSUPE_chopb  319
#define INFESEPASUPE_chopb  318
#define AOUVAOUV_chopb  317
#define ARRO_chopb  316
#define IN_chopb    315
#define PARSE_chopb     314
#define NEXTL_chopb     313
#define VALUE_chopb     312
#define INFESUPE_chopb  311
#define NL_BEG_chopb    310
#define TAB_BEG_chopb   309
#define SPACE_BEG_chopb     308
#define MAKETREE_SUP_chopb  307
#define MAKETREE_INF_chopb  306
#define PARSE_ELEM_chopb    305
#define SIMP_ETOI_chopb     304
#define ETOI_ETOI_chopb     303
#define BDECR_chopb     302
#define BINCR_chopb     301
#define ADDR_chopb  300
#define NOT_chopb   299
#define LNEG_chopb  298
#define POS_chopb   297
#define NEG_chopb   296
#define STRING_LIST_chopb   295
#define LABEL_chopb     294
#define THROW_ANSI_chopb    293
#define ELSE_chopb  292
#define TUNSIGNED_chopb     291
#define TSIGNED_chopb   290
#define TIDENT_chopb    289
#define TFLOAT_chopb    288
#define TDOUBLE_chopb   287
#define RSHI_chopb  286
#define LSHI_chopb  285
#define LT_chopb    284
#define GT_chopb    283
#define GEQU_chopb  282
#define LEQU_chopb  281
#define PROTECT_MEMB_chopb  280
#define LANGUAGE_chopb  279
#define EXP_chopb   278
#define ADECR_chopb     277
#define AINCR_chopb     276
#define ARROW_chopb     275
#define REF_chopb   274
#define EXP_ARRAY_chopb     273
#define EXP_LIST_chopb  272
#define ARROW_MEMB_chopb    271
#define DOT_MEMB_chopb  270
#define POINETOI_chopb  269
#define TIRESUPEETOI_chopb  268
#define TIRESUPE_chopb  267
#define SUPESUPE_chopb  266
#define INFEINFE_chopb  265
#define SUPEEGAL_chopb  264
#define INFEEGAL_chopb  263
#define NEW_DECLARATOR_chopb    262
#define REM_chopb   261
#define DIV_chopb   260
#define MUL_chopb   259
#define POURC_chopb     258
#define MESSAGE_MAP_chopb   257
#define MACRO_chopb     256
#define TCHAR_chopb     255
#define TSHORT_chopb    254
#define TLONG_chopb     253
#define TINT_chopb  252
#define OR_chopb    251
#define VBARVBAR_chopb  250
#define AND_chopb   249
#define ETCOETCO_chopb  248
#define COMPOUND_EXT_chopb  247
#define EXTERNAL_chopb  246
#define INITIALIZER_chopb   245
#define LOR_chopb   244
#define VBAR_chopb  243
#define FUNC_chopb  242
#define STAT_VOID_chopb     241
#define TEMPLATE_DECL_chopb     240
#define CLASS_PARAM_chopb   239
#define EXP_SEQ_chopb   238
#define LXOR_chopb  237
#define CHAP_chopb  236
#define EXCEPTION_ANSI_chopb    235
#define EXCEPTION_chopb     234
#define NEQU_chopb  233
#define EQU_chopb   232
#define EXCLEGAL_chopb  231
#define EGALEGAL_chopb  230
#define PRAGMA_chopb    229
#define INDENT_FUNCTION_TYPE_chopb  228
#define COMMENT_PLUS_chopb  227
#define COMMENT_END_chopb   226
#define COMMENT_MIDDLE_chopb    225
#define COMMENT_START_chopb     224
#define MARGIN_VALUE_chopb  223
#define BRACE_ALIGN_VALUE_chopb     222
#define ASSIGN_ALIGN_chopb  221
#define SINGLE_SWITCH_INDENT_VALUE_chopb    220
#define SIMPLIFY_VALUE_chopb    219
#define SIMPLIFY_chopb  218
#define MODE_VALUE_chopb    217
#define TAB_VALUE_chopb     216
#define CONFIG_chopb    215
#define NO_PRETTY_chopb     214
#define ERROR_chopb     213
#define UNDEF_chopb     212
#define TYP_AFF_CALL_chopb  211
#define MEMBER_DECLARATOR_chopb     210
#define TYP_ARRAY_chopb     209
#define CFER_chopb  208
#define COUV_chopb  207
#define FOR_DECLARATION_chopb   206
#define DECLARATION_chopb   205
#define CTOR_INITIALIZER_chopb  204
#define CTOR_INIT_chopb     203
#define IUN_chopb   202
#define IUNLONG_chopb   201
#define ILONG_chopb     200
#define RANGE_MODIFIER_chopb    199
#define COND_AFF_chopb  198
#define INTE_chopb  197
#define COMPOUND_chopb  196
#define PARAM_TYPE_chopb    195
#define SUPE_chopb  194
#define INFE_chopb  193
#define CLASS_DECL_chopb    192
#define AFER_chopb  191
#define CATCH_ANSI_chopb    190
#define EXCEPT_ANSI_ALL_chopb   189
#define CAST_chopb  188
#define DPOI_chopb  187
#define TYP_BIT_chopb   186
#define PROTECT_chopb   185
#define BASE_LIST_chopb     184
#define XOR_AFF_chopb   183
#define OR_AFF_chopb    182
#define AND_AFF_chopb   181
#define RSH_AFF_chopb   180
#define LSH_AFF_chopb   179
#define MIN_AFF_chopb   178
#define PLU_AFF_chopb   177
#define REM_AFF_chopb   176
#define DIV_AFF_chopb   175
#define MUL_AFF_chopb   174
#define AFF_chopb   173
#define POINPOINPOIN_chopb  172
#define VAR_LIST_chopb  171
#define TYP_LIST_chopb  170
#define TYP_AFF_chopb   169
#define ABST_DECLARATOR_chopb   168
#define DECLARATOR_chopb    167
#define LAND_chopb  166
#define INIT_NEW_chopb  165
#define VIRG_chopb  164
#define QUALIFIED_chopb     163
#define MINUS_chopb     162
#define TYP_chopb   161
#define PFER_chopb  160
#define DESTRUCT_chopb  159
#define TYP_REF_chopb   158
#define TYP_ADDR_chopb  157
#define DEFAULT_chopb   156
#define CASE_chopb  155
#define THROW_chopb     154
#define FORALLSONS_chopb    153
#define WHILE_chopb     152
#define SWITCH_chopb    151
#define RETURN_chopb    150
#define IF_chopb    149
#define FOR_chopb   148
#define DO_chopb    147
#define CONTINUE_chopb  146
#define BREAK_chopb     145
#define PVIR_chopb  144
#define TYPEDEF_chopb   143
#define TEMPLATE_chopb  142
#define TRY_chopb   141
#define EXTERN_chopb    140
#define STATIC_chopb    139
#define AUTO_chopb  138
#define AOUV_chopb  137
#define CATCH_chopb     136
#define PUBLIC_chopb    135
#define PROTECTED_chopb     134
#define PRIVATE_chopb   133
#define CHAPEGAL_chopb  132
#define VBAREGAL_chopb  131
#define ETCOEGAL_chopb  130
#define SUPESUPEEGAL_chopb  129
#define INFEINFEEGAL_chopb  128
#define TIREEGAL_chopb  127
#define PLUSEGAL_chopb  126
#define POURCEGAL_chopb     125
#define ETOIEGAL_chopb  124
#define EGAL_chopb  123
#define ASM_chopb   122
#define CLASS_chopb     121
#define UNION_chopb     120
#define STRUCT_chopb    119
#define ENUM_chopb  118
#define CONST_chopb     117
#define FRIEND_chopb    116
#define VIRTUAL_chopb   115
#define INLINE_chopb    114
#define REGISTER_chopb  113
#define VOLATILE_chopb  112
#define SHORT_chopb     111
#define UNSIGNED_chopb  110
#define SIGNED_chopb    109
#define LONG_chopb  108
#define VOID_chopb  107
#define CHAR_chopb  106
#define INT_chopb   105
#define DOUBLE_chopb    104
#define VA_ARG_chopb    103
#define OPERATOR_chopb  102
#define DELETE_chopb    101
#define NEW_chopb   100
#define DPOIDPOI_chopb  99
#define SIZEOF_chopb    98
#define TIRETIRE_chopb  97
#define PLUSPLUS_chopb  96
#define ETCO_chopb  95
#define ETOI_chopb  94
#define EXCL_chopb  93
#define TILD_chopb  92
#define PLUS_chopb  91
#define TIRE_chopb  90
#define POUV_chopb  89
#define FUNC_SPEC_chopb     88
#define TRY_UPPER_chopb     87
#define END_CATCH_chopb     86
#define END_CATCH_ALL_chopb     85
#define AND_CATCH_chopb     84
#define CATCH_UPPER_chopb   83
#define CATCH_ALL_chopb     82
#define END_MESSAGE_MAP_chopb   81
#define BEGIN_MESSAGE_MAP_chopb     80
#define DECLARE_MESSAGE_MAP_chopb   79
#define IMPLEMENT_SERIAL_chopb  78
#define IMPLEMENT_DYNCREATE_chopb   77
#define IMPLEMENT_DYNAMIC_chopb     76
#define DECLARE_SERIAL_chopb    75
#define DECLARE_DYNAMIC_chopb   74
#define PUSH_FUNCTION_chopb     73
#define PUSH_ARGUMENT_chopb     72
#define UNDEF_CONTENT_chopb     71
#define SMALL_PRAGMA_CONTENT_chopb  70
#define PRAGMA_CONTENT_chopb    69
#define PRAGMA_INDENT_FUNCTION_TYPE_chopb   68
#define PRAGMA_COMMENT_PLUS_chopb   67
#define PRAGMA_COMMENT_END_chopb    66
#define PRAGMA_COMMENT_MIDDLE_chopb     65
#define PRAGMA_COMMENT_START_chopb  64
#define PRAGMA_MARGIN_chopb     63
#define PRAGMA_ASSIGN_ALIGN_chopb   62
#define PRAGMA_SINGLE_SWITCH_INDENT_chopb   61
#define PRAGMA_SIMPLIFY_chopb   60
#define PRAGMA_BRACE_ALIGN_chopb    59
#define PRAGMA_MODE_chopb   58
#define PRAGMA_RANGE_chopb  57
#define PRAGMA_TAB_chopb    56
#define PRAGMA_CONFIG_chopb     55
#define PRAGMA_NOPRETTY_chopb   54
#define PRAGMA_PRETTY_chopb     53
#define INCLUDE_LOCAL_chopb     52
#define INCLUDE_SYS_chopb   51
#define END_LINE_chopb  50
#define DEFINE_NAME_chopb   49
#define DEFINED_NOT_CONTINUED_chopb     48
#define DEFINED_CONTINUED_chopb     47
#define POINT_chopb     46
#define SLAS_chopb  45
#define SLASEGAL_chopb  44
#define CARRIAGE_RETURN_chopb   43
#define UNDEF_DIR_chopb     42
#define DEFINE_DIR_chopb    41
#define ERROR_DIR_chopb     40
#define PRAGMA_DIR_chopb    39
#define LINE_DIR_chopb  38
#define ENDIF_DIR_chopb     37
#define ELIF_DIR_chopb  36
#define ELSE_DIR_chopb  35
#define IF_DIR_chopb    34
#define IFNDEF_DIR_chopb    33
#define IFDEF_DIR_chopb     32
#define INCLUDE_DIR_chopb   31
#define OCTAL_chopb     30
#define UOCTAL_chopb    29
#define LOCTAL_chopb    28
#define ULOCTAL_chopb   27
#define HEXA_chopb  26
#define UHEXA_chopb     25
#define LHEXA_chopb     24
#define ULHEXA_chopb    23
#define INTEGER_chopb   22
#define FLOAT_chopb     21
#define UINTEGER_chopb  20
#define LINTEGER_chopb  19
#define ULINTEGER_chopb     18
#define CHARACT_chopb   17
#define STRING_chopb    16
#define IDENT_chopb     15
#define GOTO_REL_chopb  14
#define GOTO_chopb  13
#define STR_chopb   12
#define UNMARK_chopb    11
#define MARK_chopb  10
#define TAB_VIRT_chopb  9
#define TAB_chopb   8
#define NEWLINE_chopb   7
#define ATTRIBUTS_chopb     6
#undef _Tak
#define _Tak(func) func 
#endif
