/*************************************************************************/
/*                                                                       */
/*        Chopper.c - Built by Eric Lavillonniere on Tandon 386 - 93     */
/*                                                                       */
/*************************************************************************/
/* This file is part of c++  prettyprinter */
/* Copyright(C) 1989 Eric Lavillonniere */
/*
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING. If not, write to 
   the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
   */
language chopb;

#include <stdio.h>
#include <stdlib.h>

#ifndef SUN
#include <malloc.h>
#endif

#include "decchopb.h"
#include <fcntl.h>

DecompChopb *DecompChopb::ptDecomp = 0 ;

extern "C" {
    void    ReadIncludeS (char *, int) ;
    int nb_par_parse ;
    
    PPTREE bri_parse_entry_chopb ( error_free )
    int error_free ;
    {
        return chopb().parse_entry(error_free);
    }
    
    extern PPTREE  (*the_parse_entry_pt)(int) ;
    
    PPTREE parse_chopb ( error_tree )
    int error_tree ;
    {
        return chopb().prog(error_tree);
    }
}

main ( int argc, char **argv )
{
    PTREE   tree ;
    char    name [50];
    char    *ptName ;
    DecompChopb decomp ;
    
    dumpCoord = 0 ;
    DecompChopb::ptDecomp = &decomp ;
    DecompCplus::ptDecomp = (DecompCplus *)(&decomp);
    MetaInit();
    SwitchLang("chopb");
    ReadIncludeS("c.set", 1);
    if ( argc < 2 ) {
        sprintf(name, "Bad name for your source file \n");
        write(2, name, strlen(name));
        exit(0);
    } else {
        ptName = *(argv + 1);
        input = open(ptName, O_RDONLY | O_BINARY);
    }
    the_parse_entry_pt = parse_chopb ;
    tree = ReadInFile(0);
    AddRef(tree);
    decomp.ChopTree(tree);
    MetaEnd();
    if ( !firstError ) 
        return 1 ;
    else 
        return 0 ;
}
