/*************************************************************************/
/*                                                                       */
/*        Chopper.c - Built by Eric Lavillonniere on Tandon 386 - 89     */
/*                                                                       */
/*************************************************************************/
/* Copyright(C) 1995 Eric Lavillonniere */
/*
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING. If not, write to 
   the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
   */
language chunk;

#include <stdio.h>
#include "token.h"
#include <stdio.h>
#include "token.h"
#include <sys/types.h>
#include <unistd.h>

#if !defined(SUN) || defined(LINUX)
#include <stdlib.h>
#endif

#include "chunk.h"
#include "deccplus.h"
#include <fcntl.h>

static chunk    *theParser ;
int ChopTree (PTREE) ;
void    decomp (PTREE) ;
void    copy () ;
int firstLine, lastLine, refLine ;
int find_parenthesis, nb_parenthesis ;
int comment_start ;
int lexcommentCallLex,oldLastLine;

extern "C" {
    PTREE bri_parse_entry_chunk ( int error_free )
    {
        return theParser -> parse_entry(error_free);
    }
    
    static  PPTREE getTree ( int error_free )
    {
        return theParser -> find_func(error_free);
    }
    
    extern PPTREE  (*the_parse_entry_pt)(int) ;
}

static  PPTREE quick_prog_func ( int error_free )
{
    chunk   parser ;
    
    return parser.quick_prog(error_free);
}

static  void ReadIncludeSN ( char *name, int here )
{
    PPTREE  (*keep_parse_entry)(int) ;
    char    *theName ;
    
    keep_parse_entry = the_parse_entry_pt ;
    the_parse_entry_pt = quick_prog_func ;
    theName = FindFile(name, getenv("PATH"), here);
    if ( theName ) 
        FreeTree(ReadFile(theName));
    the_parse_entry_pt = keep_parse_entry ;
}

extern int simplifyExpression;

main ( int argc, char **argv )
{
    PTREE   tree ;
    char    name [50];
    char    *ptName ;
    DecompCplus decomp ;
    
    dumpCoord = 0;
    DecompCplus::ptDecomp = &decomp ;
    MetaInit();
    output=2;
    theParser = new chunk ;
    SwitchLang("chunk");
    ReadIncludeSN("c.set", 1);
    if ( argc < 2 ) {
        sprintf(name, "Bad name for your source file \n");
        write(2, name, strlen(name));
        exit(1);
    } else {
        ptName = *(argv + 1);
        input = open(ptName, O_RDONLY | O_BINARY);
    }
    
    // initialize refLine from command argument
    if ( argc >= 3 ) {
        refLine = atoi(*(argv + 2));
    } else {
        sprintf(name, "Initial number line unknown \n");
        write(2, name, strlen(name));
        exit(1);
    }
    
    // parse tree
    the_parse_entry_pt = getTree ;
    tree = ReadInFile(0);
    AddRef(tree);
    
    //    copy();
    // unparse it
    MetaEnd();
    if ( !firstError ) 
        return 1 ;
    else {
        char    string [50];    // temporary string holder
        output=1;
        sprintf(string, "%d,%dd", firstLine, lastLine);
        WriteString(string) <NL>
        if ( firstLine > 1 ) 
            sprintf(string, "%da", firstLine - 1);
        else 
            sprintf(string, "%di", firstLine);
        WriteString(string) <NL>
        tree == <,tree>;
        decomp . ChopTree(tree,1);
        "." <NL>
        "wq" <NL>
        return 0 ;
    }
}
