 language sgt;

#include "symb.h"

// add a level to the table
int SymbolTable::AddLevel ()
{
    
    // if table is full realloc some space
    if ( pvSize == pvSizeMax ) {
        if ( !pvTable ) 
            pvTable
                = (TabList **)malloc((pvSizeMax = 10) * sizeof(TabList *));
        else {
            pvTable
                = (TabList **)realloc(pvTable
                    , (pvSizeMax += 10) * sizeof(TabList *));
        }
    }
    
    // alloc a new TabList at level +1
    pvCurrentLevel = *(pvTable + pvSize) = new TabList((PTREE)0);
    
    // return current table size
    return ++pvSize ;
}

// remove a level from the table
int SymbolTable::RemoveLevel ()
{
    
    // if table is empty do nothing
    if ( !pvSize ) 
        return 0 ;
    
    // free current TabList
    pvSize-- ;
    delete *(pvTable + pvSize);
    pvCurrentLevel = *(pvTable + pvSize - 1);
    
    // return current table size
    return pvSize ;
}

// insert a var at the current level
void SymbolTable::AddVar ( PTREE var )
{
    
    // if no level is present create one
    if ( pvSize == 0 ) 
        AddLevel();
    pvCurrentLevel -> InsertRemove(var);
}

// remove a var at the current level
void SymbolTable::RemoveVar ( PTREE var )
{
    pvCurrentLevel -> Remove(var);
}

// get a var definition
PTREE SymbolTable::GetVar ( char *var )
{
    TabList **ptLevel = pvTable + pvSize - 1 ;
    PTREE   result ;
    
    // if table is empty return NULL
    if ( !pvSize ) 
        return (PTREE)0 ;
    
    // search all level in ascending order
    for (; ptLevel >= pvTable ; ptLevel-- ) {
        if ( result = (**ptLevel)[var] ) 
            return result ;
    }
    
    // if we have found nothing return NULL
    return (PTREE)0 ;
}
