#ifndef METACHOP_PARSER
#define METACHOP_PARSER

extern char * parseLanguage;
#include "decmetac.h"
                


#ifdef __cplusplus
#include "chopb.h"
typedef int (pretty::** _FUNC_MEMB_METACHOP) ();
class metachop: public chopb {
    public :
    
    static int init ; 
    
    metachop () {
        ptTokenArray = _tokenArray;
        ptTokenFuncArray =(_FUNC_MEMB_METACHOP) _tokenFuncArray;
        ptTokenNbFuncArray = _tokenNbFuncArray;
        InitConst ();
        
    }
    
    virtual void * rootGrammar () { return (void *) this;}
    virtual int Lex() ;
    virtual PPTREE primary_expression ( int error_free) ;
    virtual PPTREE prog ( int error_free) ;
    
    
    static signed char * _tokenArray [140];
    static int (metachop::*(_tokenFuncArray [140])) ();
    static int _tokenNbFuncArray [140];

    virtual int SortKeyWord (int ret);
    virtual int UpSortKeyWord (int ret); 
    virtual void InitConst ();
    
    enum constants {
        NODE_LIST =     338 ,
        NODE_TREE =     337 ,
        SPACE =     336 ,
        SEP_OMIT =  335 ,
        SEP_BEFORE =    334 ,
        SEP_AFTER =     333 ,
        AFERAFER =  332 ,
        ALINEA =    331 ,
        CHOP_DEF =  330 ,
        NIL =   329 ,
        IN_LANG =   328 ,
        NEXT =  327 ,
        DEF_IDENT =     326 ,
        BOX =   325 ,
        EXPO =  324 ,
        EXPO_AFF =  323 ,
        ETOIETOIEGAL =  322 ,
        FOREACH =   321 ,
        INFESEPOSUPE =  320 ,
        INFESEPBSUPE =  319 ,
        INFESEPASUPE =  318 ,
        AOUVAOUV =  317 ,
        ARRO =  316 ,
        IN =    315 ,
        PARSE =     314 ,
        NEXTL =     313 ,
        VALUE =     312 ,
        INFESUPE =  311 ,
        NL_BEG =    310 ,
        TAB_BEG =   309 ,
        SPACE_BEG =     308 ,
        MAKETREE_SUP =  307 ,
        MAKETREE_INF =  306 ,
        PARSE_ELEM =    305 ,
        SIMP_ETOI =     304 ,
        ETOI_ETOI =     303 ,
        BDECR =     302 ,
        BINCR =     301 ,
        ADDR =  300 ,
        NOT =   299 ,
        LNEG =  298 ,
        POS =   297 ,
        NEG =   296 ,
        STRING_LIST =   295 ,
        LABEL =     294 ,
        THROW_ANSI =    293 ,
        ELSE =  292 ,
        TUNSIGNED =     291 ,
        TSIGNED =   290 ,
        TIDENT =    289 ,
        TFLOAT =    288 ,
        TDOUBLE =   287 ,
        RSHI =  286 ,
        LSHI =  285 ,
        LT =    284 ,
        GT =    283 ,
        GEQU =  282 ,
        LEQU =  281 ,
        PROTECT_MEMB =  280 ,
        LANGUAGE =  279 ,
        EXP =   278 ,
        ADECR =     277 ,
        AINCR =     276 ,
        ARROW =     275 ,
        REF =   274 ,
        EXP_ARRAY =     273 ,
        EXP_LIST =  272 ,
        ARROW_MEMB =    271 ,
        DOT_MEMB =  270 ,
        POINETOI =  269 ,
        TIRESUPEETOI =  268 ,
        TIRESUPE =  267 ,
        SUPESUPE =  266 ,
        INFEINFE =  265 ,
        SUPEEGAL =  264 ,
        INFEEGAL =  263 ,
        NEW_DECLARATOR =    262 ,
        REM =   261 ,
        DIV =   260 ,
        MUL =   259 ,
        POURC =     258 ,
        MESSAGE_MAP =   257 ,
        MACRO =     256 ,
        TCHAR =     255 ,
        TSHORT =    254 ,
        TLONG =     253 ,
        TINT =  252 ,
        OR =    251 ,
        VBARVBAR =  250 ,
        AND =   249 ,
        ETCOETCO =  248 ,
        COMPOUND_EXT =  247 ,
        EXTERNAL =  246 ,
        INITIALIZER =   245 ,
        LOR =   244 ,
        VBAR =  243 ,
        FUNC =  242 ,
        STAT_VOID =     241 ,
        TEMPLATE_DECL =     240 ,
        CLASS_PARAM =   239 ,
        EXP_SEQ =   238 ,
        LXOR =  237 ,
        CHAP =  236 ,
        EXCEPTION_ANSI =    235 ,
        EXCEPTION =     234 ,
        NEQU =  233 ,
        EQU =   232 ,
        EXCLEGAL =  231 ,
        EGALEGAL =  230 ,
        PRAGMA =    229 ,
        INDENT_FUNCTION_TYPE =  228 ,
        COMMENT_PLUS =  227 ,
        COMMENT_END =   226 ,
        COMMENT_MIDDLE =    225 ,
        COMMENT_START =     224 ,
        MARGIN_VALUE =  223 ,
        BRACE_ALIGN_VALUE =     222 ,
        ASSIGN_ALIGN =  221 ,
        SINGLE_SWITCH_INDENT_VALUE =    220 ,
        SIMPLIFY_VALUE =    219 ,
        SIMPLIFY =  218 ,
        MODE_VALUE =    217 ,
        TAB_VALUE =     216 ,
        CONFIG =    215 ,
        NO_PRETTY =     214 ,
        ERROR =     213 ,
        UNDEF =     212 ,
        TYP_AFF_CALL =  211 ,
        MEMBER_DECLARATOR =     210 ,
        TYP_ARRAY =     209 ,
        CFER =  208 ,
        COUV =  207 ,
        FOR_DECLARATION =   206 ,
        DECLARATION =   205 ,
        CTOR_INITIALIZER =  204 ,
        CTOR_INIT =     203 ,
        IUN =   202 ,
        IUNLONG =   201 ,
        ILONG =     200 ,
        RANGE_MODIFIER =    199 ,
        COND_AFF =  198 ,
        INTE =  197 ,
        COMPOUND =  196 ,
        PARAM_TYPE =    195 ,
        SUPE =  194 ,
        INFE =  193 ,
        CLASS_DECL =    192 ,
        AFER =  191 ,
        CATCH_ANSI =    190 ,
        EXCEPT_ANSI_ALL =   189 ,
        CAST =  188 ,
        DPOI =  187 ,
        TYP_BIT =   186 ,
        PROTECT =   185 ,
        BASE_LIST =     184 ,
        XOR_AFF =   183 ,
        OR_AFF =    182 ,
        AND_AFF =   181 ,
        RSH_AFF =   180 ,
        LSH_AFF =   179 ,
        MIN_AFF =   178 ,
        PLU_AFF =   177 ,
        REM_AFF =   176 ,
        DIV_AFF =   175 ,
        MUL_AFF =   174 ,
        AFF =   173 ,
        POINPOINPOIN =  172 ,
        VAR_LIST =  171 ,
        TYP_LIST =  170 ,
        TYP_AFF =   169 ,
        ABST_DECLARATOR =   168 ,
        DECLARATOR =    167 ,
        LAND =  166 ,
        INIT_NEW =  165 ,
        VIRG =  164 ,
        QUALIFIED =     163 ,
        MINUS =     162 ,
        TYP =   161 ,
        PFER =  160 ,
        DESTRUCT =  159 ,
        TYP_REF =   158 ,
        TYP_ADDR =  157 ,
        DEFAULT =   156 ,
        CASE =  155 ,
        THROW =     154 ,
        FORALLSONS =    153 ,
        WHILE =     152 ,
        SWITCH =    151 ,
        RETURN =    150 ,
        IF =    149 ,
        FOR =   148 ,
        DO =    147 ,
        CONTINUE =  146 ,
        BREAK =     145 ,
        PVIR =  144 ,
        TYPEDEF =   143 ,
        TEMPLATE =  142 ,
        TRY =   141 ,
        EXTERN =    140 ,
        STATIC =    139 ,
        AUTO =  138 ,
        AOUV =  137 ,
        CATCH =     136 ,
        PUBLIC =    135 ,
        PROTECTED =     134 ,
        PRIVATE =   133 ,
        CHAPEGAL =  132 ,
        VBAREGAL =  131 ,
        ETCOEGAL =  130 ,
        SUPESUPEEGAL =  129 ,
        INFEINFEEGAL =  128 ,
        TIREEGAL =  127 ,
        PLUSEGAL =  126 ,
        POURCEGAL =     125 ,
        ETOIEGAL =  124 ,
        EGAL =  123 ,
        ASM =   122 ,
        CLASS =     121 ,
        UNION =     120 ,
        STRUCT =    119 ,
        ENUM =  118 ,
        CONST =     117 ,
        FRIEND =    116 ,
        VIRTUAL =   115 ,
        INLINE =    114 ,
        REGISTER =  113 ,
        VOLATILE =  112 ,
        SHORT =     111 ,
        UNSIGNED =  110 ,
        SIGNED =    109 ,
        LONG =  108 ,
        VOID =  107 ,
        CHAR =  106 ,
        INT =   105 ,
        DOUBLE =    104 ,
        VA_ARG =    103 ,
        OPERATOR =  102 ,
        DELETE =    101 ,
        NEW =   100 ,
        DPOIDPOI =  99 ,
        SIZEOF =    98 ,
        TIRETIRE =  97 ,
        PLUSPLUS =  96 ,
        ETCO =  95 ,
        ETOI =  94 ,
        EXCL =  93 ,
        TILD =  92 ,
        PLUS =  91 ,
        TIRE =  90 ,
        POUV =  89 ,
        FUNC_SPEC =     88 ,
        TRY_UPPER =     87 ,
        END_CATCH =     86 ,
        END_CATCH_ALL =     85 ,
        AND_CATCH =     84 ,
        CATCH_UPPER =   83 ,
        CATCH_ALL =     82 ,
        END_MESSAGE_MAP =   81 ,
        BEGIN_MESSAGE_MAP =     80 ,
        DECLARE_MESSAGE_MAP =   79 ,
        IMPLEMENT_SERIAL =  78 ,
        IMPLEMENT_DYNCREATE =   77 ,
        IMPLEMENT_DYNAMIC =     76 ,
        DECLARE_SERIAL =    75 ,
        DECLARE_DYNAMIC =   74 ,
        PUSH_FUNCTION =     73 ,
        PUSH_ARGUMENT =     72 ,
        UNDEF_CONTENT =     71 ,
        SMALL_PRAGMA_CONTENT =  70 ,
        PRAGMA_CONTENT =    69 ,
        PRAGMA_INDENT_FUNCTION_TYPE =   68 ,
        PRAGMA_COMMENT_PLUS =   67 ,
        PRAGMA_COMMENT_END =    66 ,
        PRAGMA_COMMENT_MIDDLE =     65 ,
        PRAGMA_COMMENT_START =  64 ,
        PRAGMA_MARGIN =     63 ,
        PRAGMA_ASSIGN_ALIGN =   62 ,
        PRAGMA_SINGLE_SWITCH_INDENT =   61 ,
        PRAGMA_SIMPLIFY =   60 ,
        PRAGMA_BRACE_ALIGN =    59 ,
        PRAGMA_MODE =   58 ,
        PRAGMA_RANGE =  57 ,
        PRAGMA_TAB =    56 ,
        PRAGMA_CONFIG =     55 ,
        PRAGMA_NOPRETTY =   54 ,
        PRAGMA_PRETTY =     53 ,
        INCLUDE_LOCAL =     52 ,
        INCLUDE_SYS =   51 ,
        END_LINE =  50 ,
        DEFINE_NAME =   49 ,
        DEFINED_NOT_CONTINUED =     48 ,
        DEFINED_CONTINUED =     47 ,
        POINT =     46 ,
        SLAS =  45 ,
        SLASEGAL =  44 ,
        CARRIAGE_RETURN =   43 ,
        UNDEF_DIR =     42 ,
        DEFINE_DIR =    41 ,
        ERROR_DIR =     40 ,
        PRAGMA_DIR =    39 ,
        LINE_DIR =  38 ,
        ENDIF_DIR =     37 ,
        ELIF_DIR =  36 ,
        ELSE_DIR =  35 ,
        IF_DIR =    34 ,
        IFNDEF_DIR =    33 ,
        IFDEF_DIR =     32 ,
        INCLUDE_DIR =   31 ,
        OCTAL =     30 ,
        UOCTAL =    29 ,
        LOCTAL =    28 ,
        ULOCTAL =   27 ,
        HEXA =  26 ,
        UHEXA =     25 ,
        LHEXA =     24 ,
        ULHEXA =    23 ,
        INTEGER =   22 ,
        FLOAT =     21 ,
        UINTEGER =  20 ,
        LINTEGER =  19 ,
        ULINTEGER =     18 ,
        CHARACT =   17 ,
        STRING =    16 ,
        IDENT =     15 ,
        GOTO_REL =  14 ,
        GOTO =  13 ,
        STR =   12 ,
        UNMARK =    11 ,
        MARK =  10 ,
        TAB_VIRT =  9 ,
        TAB =   8 ,
        NEWLINE =   7 ,
        ATTRIBUTS =     6 ,
        PLACE_HOLD_CONST
    } ; 
} ; 

extern metachop * parser_metachop;

#endif
#define NODE_LIST_metachop  338
#define NODE_TREE_metachop  337
#define SPACE_metachop  336
#define SEP_OMIT_metachop   335
#define SEP_BEFORE_metachop     334
#define SEP_AFTER_metachop  333
#define AFERAFER_metachop   332
#define ALINEA_metachop     331
#define CHOP_DEF_metachop   330
#define NIL_metachop    329
#define IN_LANG_metachop    328
#define NEXT_metachop   327
#define DEF_IDENT_metachop  326
#define BOX_metachop    325
#define EXPO_metachop   324
#define EXPO_AFF_metachop   323
#define ETOIETOIEGAL_metachop   322
#define FOREACH_metachop    321
#define INFESEPOSUPE_metachop   320
#define INFESEPBSUPE_metachop   319
#define INFESEPASUPE_metachop   318
#define AOUVAOUV_metachop   317
#define ARRO_metachop   316
#define IN_metachop     315
#define PARSE_metachop  314
#define NEXTL_metachop  313
#define VALUE_metachop  312
#define INFESUPE_metachop   311
#define NL_BEG_metachop     310
#define TAB_BEG_metachop    309
#define SPACE_BEG_metachop  308
#define MAKETREE_SUP_metachop   307
#define MAKETREE_INF_metachop   306
#define PARSE_ELEM_metachop     305
#define SIMP_ETOI_metachop  304
#define ETOI_ETOI_metachop  303
#define BDECR_metachop  302
#define BINCR_metachop  301
#define ADDR_metachop   300
#define NOT_metachop    299
#define LNEG_metachop   298
#define POS_metachop    297
#define NEG_metachop    296
#define STRING_LIST_metachop    295
#define LABEL_metachop  294
#define THROW_ANSI_metachop     293
#define ELSE_metachop   292
#define TUNSIGNED_metachop  291
#define TSIGNED_metachop    290
#define TIDENT_metachop     289
#define TFLOAT_metachop     288
#define TDOUBLE_metachop    287
#define RSHI_metachop   286
#define LSHI_metachop   285
#define LT_metachop     284
#define GT_metachop     283
#define GEQU_metachop   282
#define LEQU_metachop   281
#define PROTECT_MEMB_metachop   280
#define LANGUAGE_metachop   279
#define EXP_metachop    278
#define ADECR_metachop  277
#define AINCR_metachop  276
#define ARROW_metachop  275
#define REF_metachop    274
#define EXP_ARRAY_metachop  273
#define EXP_LIST_metachop   272
#define ARROW_MEMB_metachop     271
#define DOT_MEMB_metachop   270
#define POINETOI_metachop   269
#define TIRESUPEETOI_metachop   268
#define TIRESUPE_metachop   267
#define SUPESUPE_metachop   266
#define INFEINFE_metachop   265
#define SUPEEGAL_metachop   264
#define INFEEGAL_metachop   263
#define NEW_DECLARATOR_metachop     262
#define REM_metachop    261
#define DIV_metachop    260
#define MUL_metachop    259
#define POURC_metachop  258
#define MESSAGE_MAP_metachop    257
#define MACRO_metachop  256
#define TCHAR_metachop  255
#define TSHORT_metachop     254
#define TLONG_metachop  253
#define TINT_metachop   252
#define OR_metachop     251
#define VBARVBAR_metachop   250
#define AND_metachop    249
#define ETCOETCO_metachop   248
#define COMPOUND_EXT_metachop   247
#define EXTERNAL_metachop   246
#define INITIALIZER_metachop    245
#define LOR_metachop    244
#define VBAR_metachop   243
#define FUNC_metachop   242
#define STAT_VOID_metachop  241
#define TEMPLATE_DECL_metachop  240
#define CLASS_PARAM_metachop    239
#define EXP_SEQ_metachop    238
#define LXOR_metachop   237
#define CHAP_metachop   236
#define EXCEPTION_ANSI_metachop     235
#define EXCEPTION_metachop  234
#define NEQU_metachop   233
#define EQU_metachop    232
#define EXCLEGAL_metachop   231
#define EGALEGAL_metachop   230
#define PRAGMA_metachop     229
#define INDENT_FUNCTION_TYPE_metachop   228
#define COMMENT_PLUS_metachop   227
#define COMMENT_END_metachop    226
#define COMMENT_MIDDLE_metachop     225
#define COMMENT_START_metachop  224
#define MARGIN_VALUE_metachop   223
#define BRACE_ALIGN_VALUE_metachop  222
#define ASSIGN_ALIGN_metachop   221
#define SINGLE_SWITCH_INDENT_VALUE_metachop     220
#define SIMPLIFY_VALUE_metachop     219
#define SIMPLIFY_metachop   218
#define MODE_VALUE_metachop     217
#define TAB_VALUE_metachop  216
#define CONFIG_metachop     215
#define NO_PRETTY_metachop  214
#define ERROR_metachop  213
#define UNDEF_metachop  212
#define TYP_AFF_CALL_metachop   211
#define MEMBER_DECLARATOR_metachop  210
#define TYP_ARRAY_metachop  209
#define CFER_metachop   208
#define COUV_metachop   207
#define FOR_DECLARATION_metachop    206
#define DECLARATION_metachop    205
#define CTOR_INITIALIZER_metachop   204
#define CTOR_INIT_metachop  203
#define IUN_metachop    202
#define IUNLONG_metachop    201
#define ILONG_metachop  200
#define RANGE_MODIFIER_metachop     199
#define COND_AFF_metachop   198
#define INTE_metachop   197
#define COMPOUND_metachop   196
#define PARAM_TYPE_metachop     195
#define SUPE_metachop   194
#define INFE_metachop   193
#define CLASS_DECL_metachop     192
#define AFER_metachop   191
#define CATCH_ANSI_metachop     190
#define EXCEPT_ANSI_ALL_metachop    189
#define CAST_metachop   188
#define DPOI_metachop   187
#define TYP_BIT_metachop    186
#define PROTECT_metachop    185
#define BASE_LIST_metachop  184
#define XOR_AFF_metachop    183
#define OR_AFF_metachop     182
#define AND_AFF_metachop    181
#define RSH_AFF_metachop    180
#define LSH_AFF_metachop    179
#define MIN_AFF_metachop    178
#define PLU_AFF_metachop    177
#define REM_AFF_metachop    176
#define DIV_AFF_metachop    175
#define MUL_AFF_metachop    174
#define AFF_metachop    173
#define POINPOINPOIN_metachop   172
#define VAR_LIST_metachop   171
#define TYP_LIST_metachop   170
#define TYP_AFF_metachop    169
#define ABST_DECLARATOR_metachop    168
#define DECLARATOR_metachop     167
#define LAND_metachop   166
#define INIT_NEW_metachop   165
#define VIRG_metachop   164
#define QUALIFIED_metachop  163
#define MINUS_metachop  162
#define TYP_metachop    161
#define PFER_metachop   160
#define DESTRUCT_metachop   159
#define TYP_REF_metachop    158
#define TYP_ADDR_metachop   157
#define DEFAULT_metachop    156
#define CASE_metachop   155
#define THROW_metachop  154
#define FORALLSONS_metachop     153
#define WHILE_metachop  152
#define SWITCH_metachop     151
#define RETURN_metachop     150
#define IF_metachop     149
#define FOR_metachop    148
#define DO_metachop     147
#define CONTINUE_metachop   146
#define BREAK_metachop  145
#define PVIR_metachop   144
#define TYPEDEF_metachop    143
#define TEMPLATE_metachop   142
#define TRY_metachop    141
#define EXTERN_metachop     140
#define STATIC_metachop     139
#define AUTO_metachop   138
#define AOUV_metachop   137
#define CATCH_metachop  136
#define PUBLIC_metachop     135
#define PROTECTED_metachop  134
#define PRIVATE_metachop    133
#define CHAPEGAL_metachop   132
#define VBAREGAL_metachop   131
#define ETCOEGAL_metachop   130
#define SUPESUPEEGAL_metachop   129
#define INFEINFEEGAL_metachop   128
#define TIREEGAL_metachop   127
#define PLUSEGAL_metachop   126
#define POURCEGAL_metachop  125
#define ETOIEGAL_metachop   124
#define EGAL_metachop   123
#define ASM_metachop    122
#define CLASS_metachop  121
#define UNION_metachop  120
#define STRUCT_metachop     119
#define ENUM_metachop   118
#define CONST_metachop  117
#define FRIEND_metachop     116
#define VIRTUAL_metachop    115
#define INLINE_metachop     114
#define REGISTER_metachop   113
#define VOLATILE_metachop   112
#define SHORT_metachop  111
#define UNSIGNED_metachop   110
#define SIGNED_metachop     109
#define LONG_metachop   108
#define VOID_metachop   107
#define CHAR_metachop   106
#define INT_metachop    105
#define DOUBLE_metachop     104
#define VA_ARG_metachop     103
#define OPERATOR_metachop   102
#define DELETE_metachop     101
#define NEW_metachop    100
#define DPOIDPOI_metachop   99
#define SIZEOF_metachop     98
#define TIRETIRE_metachop   97
#define PLUSPLUS_metachop   96
#define ETCO_metachop   95
#define ETOI_metachop   94
#define EXCL_metachop   93
#define TILD_metachop   92
#define PLUS_metachop   91
#define TIRE_metachop   90
#define POUV_metachop   89
#define FUNC_SPEC_metachop  88
#define TRY_UPPER_metachop  87
#define END_CATCH_metachop  86
#define END_CATCH_ALL_metachop  85
#define AND_CATCH_metachop  84
#define CATCH_UPPER_metachop    83
#define CATCH_ALL_metachop  82
#define END_MESSAGE_MAP_metachop    81
#define BEGIN_MESSAGE_MAP_metachop  80
#define DECLARE_MESSAGE_MAP_metachop    79
#define IMPLEMENT_SERIAL_metachop   78
#define IMPLEMENT_DYNCREATE_metachop    77
#define IMPLEMENT_DYNAMIC_metachop  76
#define DECLARE_SERIAL_metachop     75
#define DECLARE_DYNAMIC_metachop    74
#define PUSH_FUNCTION_metachop  73
#define PUSH_ARGUMENT_metachop  72
#define UNDEF_CONTENT_metachop  71
#define SMALL_PRAGMA_CONTENT_metachop   70
#define PRAGMA_CONTENT_metachop     69
#define PRAGMA_INDENT_FUNCTION_TYPE_metachop    68
#define PRAGMA_COMMENT_PLUS_metachop    67
#define PRAGMA_COMMENT_END_metachop     66
#define PRAGMA_COMMENT_MIDDLE_metachop  65
#define PRAGMA_COMMENT_START_metachop   64
#define PRAGMA_MARGIN_metachop  63
#define PRAGMA_ASSIGN_ALIGN_metachop    62
#define PRAGMA_SINGLE_SWITCH_INDENT_metachop    61
#define PRAGMA_SIMPLIFY_metachop    60
#define PRAGMA_BRACE_ALIGN_metachop     59
#define PRAGMA_MODE_metachop    58
#define PRAGMA_RANGE_metachop   57
#define PRAGMA_TAB_metachop     56
#define PRAGMA_CONFIG_metachop  55
#define PRAGMA_NOPRETTY_metachop    54
#define PRAGMA_PRETTY_metachop  53
#define INCLUDE_LOCAL_metachop  52
#define INCLUDE_SYS_metachop    51
#define END_LINE_metachop   50
#define DEFINE_NAME_metachop    49
#define DEFINED_NOT_CONTINUED_metachop  48
#define DEFINED_CONTINUED_metachop  47
#define POINT_metachop  46
#define SLAS_metachop   45
#define SLASEGAL_metachop   44
#define CARRIAGE_RETURN_metachop    43
#define UNDEF_DIR_metachop  42
#define DEFINE_DIR_metachop     41
#define ERROR_DIR_metachop  40
#define PRAGMA_DIR_metachop     39
#define LINE_DIR_metachop   38
#define ENDIF_DIR_metachop  37
#define ELIF_DIR_metachop   36
#define ELSE_DIR_metachop   35
#define IF_DIR_metachop     34
#define IFNDEF_DIR_metachop     33
#define IFDEF_DIR_metachop  32
#define INCLUDE_DIR_metachop    31
#define OCTAL_metachop  30
#define UOCTAL_metachop     29
#define LOCTAL_metachop     28
#define ULOCTAL_metachop    27
#define HEXA_metachop   26
#define UHEXA_metachop  25
#define LHEXA_metachop  24
#define ULHEXA_metachop     23
#define INTEGER_metachop    22
#define FLOAT_metachop  21
#define UINTEGER_metachop   20
#define LINTEGER_metachop   19
#define ULINTEGER_metachop  18
#define CHARACT_metachop    17
#define STRING_metachop     16
#define IDENT_metachop  15
#define GOTO_REL_metachop   14
#define GOTO_metachop   13
#define STR_metachop    12
#define UNMARK_metachop     11
#define MARK_metachop   10
#define TAB_VIRT_metachop   9
#define TAB_metachop    8
#define NEWLINE_metachop    7
#define ATTRIBUTS_metachop  6
#undef _Tak
#define _Tak(func) func 
#endif
