#ifndef METACHOP_PARSER
#define METACHOP_PARSER

extern char * parseLanguage;
#include "decmetac.h"
                


#ifdef __cplusplus
#include "chopb.h"
#ifndef FUNC_MEMBER_DEF
#define FUNC_MEMBER_DEF 1
typedef int (pretty::** _FUNC_MEMB) ();
#endif
class metachop: public chopb {
    public :
    
    static int init ; 
    
    metachop () {
        ptTokenArray = _tokenArray;
        ptTokenFuncArray =(_FUNC_MEMB) _tokenFuncArray;
        ptTokenNbFuncArray = _tokenNbFuncArray;
        InitConst ();
        
    }
    
    virtual void * rootGrammar () { return (void *) this;}
    virtual int Lex() ;
    virtual PPTREE primary_expression ( int error_free) ;
    virtual PPTREE prog ( int error_free) ;
    
    
    static signed char * _tokenArray [137];
    static int (metachop::*(_tokenFuncArray [137])) ();
    static int _tokenNbFuncArray [137];

    virtual int SortKeyWord (int ret);
    virtual int UpSortKeyWord (int ret); 
    virtual void InitConst ();
    
    enum constants {
        NODE_LIST =     332 ,
        NODE_TREE =     331 ,
        SPACE =     330 ,
        SEP_OMIT =  329 ,
        SEP_BEFORE =    328 ,
        SEP_AFTER =     327 ,
        AFERAFER =  326 ,
        ALINEA =    325 ,
        CFERCFER =  324 ,
        BOX =   323 ,
        CHOP_DEF =  322 ,
        NIL =   321 ,
        IN_LANG =   320 ,
        NEXT =  319 ,
        DEF_IDENT =     318 ,
        EXPO =  317 ,
        EXPO_AFF =  316 ,
        ETOIETOIEGAL =  315 ,
        FOREACH =   314 ,
        INFESEPOSUPE =  313 ,
        INFESEPBSUPE =  312 ,
        INFESEPASUPE =  311 ,
        AOUVAOUV =  310 ,
        COUVCOUV =  309 ,
        ARRO =  308 ,
        IN =    307 ,
        PARSE =     306 ,
        NEXTL =     305 ,
        VALUE =     304 ,
        INFESUPE =  303 ,
        NL_BEG =    302 ,
        TAB_BEG =   301 ,
        SPACE_BEG =     300 ,
        MAKETREE_SUP =  299 ,
        MAKETREE_INF =  298 ,
        PARSE_ELEM =    297 ,
        SIMP_ETOI =     296 ,
        ETOI_ETOI =     295 ,
        BDECR =     294 ,
        BINCR =     293 ,
        ADDR =  292 ,
        POINT =     291 ,
        NOT =   290 ,
        LNEG =  289 ,
        POS =   288 ,
        NEG =   287 ,
        STRING_LIST =   286 ,
        LABEL =     285 ,
        ELSE =  284 ,
        TUNSIGNED =     283 ,
        TSIGNED =   282 ,
        TIDENT =    281 ,
        TFLOAT =    280 ,
        TDOUBLE =   279 ,
        RSHI =  278 ,
        LSHI =  277 ,
        LT =    276 ,
        GT =    275 ,
        GEQU =  274 ,
        LEQU =  273 ,
        PROTECT_MEMB =  272 ,
        LANGUAGE =  271 ,
        EXP =   270 ,
        ADECR =     269 ,
        AINCR =     268 ,
        ARROW =     267 ,
        REF =   266 ,
        EXP_ARRAY =     265 ,
        EXP_LIST =  264 ,
        POIN =  263 ,
        ARROW_MEMB =    262 ,
        DOT_MEMB =  261 ,
        POINETOI =  260 ,
        PARAM_TYPE =    259 ,
        TIRESUPEETOI =  258 ,
        TIRESUPE =  257 ,
        SUPESUPE =  256 ,
        INFEINFE =  255 ,
        SUPEEGAL =  254 ,
        INFEEGAL =  253 ,
        NEW_DECLARATOR =    252 ,
        REM =   251 ,
        DIV =   250 ,
        MUL =   249 ,
        POURC =     248 ,
        MESSAGE_MAP =   247 ,
        MACRO =     246 ,
        TCHAR =     245 ,
        TSHORT =    244 ,
        TLONG =     243 ,
        TINT =  242 ,
        OR =    241 ,
        VBARVBAR =  240 ,
        AND =   239 ,
        ETCOETCO =  238 ,
        COMPOUND_EXT =  237 ,
        EXTERNAL =  236 ,
        INITIALIZER =   235 ,
        LOR =   234 ,
        VBAR =  233 ,
        FUNC =  232 ,
        STAT_VOID =     231 ,
        TEMPLATE_DECL =     230 ,
        SUPE =  229 ,
        INFE =  228 ,
        EXP_SEQ =   227 ,
        LXOR =  226 ,
        CHAP =  225 ,
        EXCEPTION =     224 ,
        NEQU =  223 ,
        EQU =   222 ,
        EXCLEGAL =  221 ,
        EGALEGAL =  220 ,
        PRAGMA =    219 ,
        INDENT_FUNCTION_TYPE =  218 ,
        COMMENT_PLUS =  217 ,
        COMMENT_END =   216 ,
        COMMENT_MIDDLE =    215 ,
        COMMENT_START =     214 ,
        MARGIN_VALUE =  213 ,
        BRACE_ALIGN_VALUE =     212 ,
        ASSIGN_ALIGN =  211 ,
        SINGLE_SWITCH_INDENT_VALUE =    210 ,
        SIMPLIFY_VALUE =    209 ,
        SIMPLIFY =  208 ,
        MODE_VALUE =    207 ,
        TAB_VALUE =     206 ,
        CONFIG =    205 ,
        NO_PRETTY =     204 ,
        ERROR =     203 ,
        UNDEF =     202 ,
        TYP_AFF_CALL =  201 ,
        MEMBER_DECLARATOR =     200 ,
        TYP_ARRAY =     199 ,
        CFER =  198 ,
        COUV =  197 ,
        FOR_DECLARATION =   196 ,
        DECLARATION =   195 ,
        CTOR_INITIALIZER =  194 ,
        CTOR_INIT =     193 ,
        IUN =   192 ,
        IUNLONG =   191 ,
        ILONG =     190 ,
        RANGE_MODIFIER =    189 ,
        COND_AFF =  188 ,
        INTE =  187 ,
        COMPOUND =  186 ,
        CLASS_DECL =    185 ,
        AFER =  184 ,
        CAST =  183 ,
        DPOI =  182 ,
        TYP_BIT =   181 ,
        PROTECT =   180 ,
        BASE_LIST =     179 ,
        XOR_AFF =   178 ,
        OR_AFF =    177 ,
        AND_AFF =   176 ,
        RSH_AFF =   175 ,
        LSH_AFF =   174 ,
        MIN_AFF =   173 ,
        PLU_AFF =   172 ,
        REM_AFF =   171 ,
        DIV_AFF =   170 ,
        MUL_AFF =   169 ,
        AFF =   168 ,
        POINPOINPOIN =  167 ,
        VAR_LIST =  166 ,
        TYP_LIST =  165 ,
        TYP_AFF =   164 ,
        ABST_DECLARATOR =   163 ,
        DECLARATOR =    162 ,
        LAND =  161 ,
        INIT_NEW =  160 ,
        VIRG =  159 ,
        QUALIFIED =     158 ,
        MINUS =     157 ,
        TYP =   156 ,
        PFER =  155 ,
        DESTRUCT =  154 ,
        TYP_REF =   153 ,
        TYP_ADDR =  152 ,
        DEFAULT =   151 ,
        CASE =  150 ,
        FORALLSONS =    149 ,
        WHILE =     148 ,
        SWITCH =    147 ,
        RETURN =    146 ,
        IF =    145 ,
        FOR =   144 ,
        DO =    143 ,
        CONTINUE =  142 ,
        BREAK =     141 ,
        PVIR =  140 ,
        TYPEDEF =   139 ,
        TEMPLATE =  138 ,
        EXTERN =    137 ,
        STATIC =    136 ,
        AUTO =  135 ,
        AOUV =  134 ,
        PUBLIC =    133 ,
        PROTECTED =     132 ,
        PRIVATE =   131 ,
        CHAPEGAL =  130 ,
        VBAREGAL =  129 ,
        ETCOEGAL =  128 ,
        SUPESUPEEGAL =  127 ,
        INFEINFEEGAL =  126 ,
        TIREEGAL =  125 ,
        PLUSEGAL =  124 ,
        POURCEGAL =     123 ,
        ETOIEGAL =  122 ,
        EGAL =  121 ,
        ASM =   120 ,
        CLASS =     119 ,
        UNION =     118 ,
        STRUCT =    117 ,
        ENUM =  116 ,
        CONST =     115 ,
        FRIEND =    114 ,
        VIRTUAL =   113 ,
        INLINE =    112 ,
        REGISTER =  111 ,
        VOLATILE =  110 ,
        SHORT =     109 ,
        UNSIGNED =  108 ,
        SIGNED =    107 ,
        LONG =  106 ,
        VOID =  105 ,
        CHAR =  104 ,
        INT =   103 ,
        DOUBLE =    102 ,
        VA_ARG =    101 ,
        OPERATOR =  100 ,
        DELETE =    99 ,
        NEW =   98 ,
        DPOIDPOI =  97 ,
        SIZEOF =    96 ,
        TIRETIRE =  95 ,
        PLUSPLUS =  94 ,
        ETCO =  93 ,
        ETOI =  92 ,
        EXCL =  91 ,
        TILD =  90 ,
        PLUS =  89 ,
        TIRE =  88 ,
        POUV =  87 ,
        FUNC_SPEC =     86 ,
        TRY =   85 ,
        END_CATCH =     84 ,
        END_CATCH_ALL =     83 ,
        AND_CATCH =     82 ,
        CATCH =     81 ,
        CATCH_ALL =     80 ,
        END_MESSAGE_MAP =   79 ,
        BEGIN_MESSAGE_MAP =     78 ,
        DECLARE_MESSAGE_MAP =   77 ,
        IMPLEMENT_SERIAL =  76 ,
        IMPLEMENT_DYNCREATE =   75 ,
        IMPLEMENT_DYNAMIC =     74 ,
        DECLARE_SERIAL =    73 ,
        DECLARE_DYNAMIC =   72 ,
        PUSH_FUNCTION =     71 ,
        PUSH_ARGUMENT =     70 ,
        UNDEF_CONTENT =     69 ,
        SMALL_PRAGMA_CONTENT =  68 ,
        PRAGMA_CONTENT =    67 ,
        PRAGMA_INDENT_FUNCTION_TYPE =   66 ,
        PRAGMA_COMMENT_PLUS =   65 ,
        PRAGMA_COMMENT_END =    64 ,
        PRAGMA_COMMENT_MIDDLE =     63 ,
        PRAGMA_COMMENT_START =  62 ,
        PRAGMA_MARGIN =     61 ,
        PRAGMA_ASSIGN_ALIGN =   60 ,
        PRAGMA_SINGLE_SWITCH_INDENT =   59 ,
        PRAGMA_SIMPLIFY =   58 ,
        PRAGMA_BRACE_ALIGN =    57 ,
        PRAGMA_MODE =   56 ,
        PRAGMA_RANGE =  55 ,
        PRAGMA_TAB =    54 ,
        PRAGMA_CONFIG =     53 ,
        PRAGMA_NOPRETTY =   52 ,
        PRAGMA_PRETTY =     51 ,
        INCLUDE_LOCAL =     50 ,
        INCLUDE_SYS =   49 ,
        END_LINE =  48 ,
        DEFINE_NAME =   47 ,
        DEFINED_NOT_CONTINUED =     46 ,
        DEFINED_CONTINUED =     45 ,
        SLAS =  44 ,
        SLASEGAL =  43 ,
        CARRIAGE_RETURN =   42 ,
        UNDEF_DIR =     41 ,
        DEFINE_DIR =    40 ,
        ERROR_DIR =     39 ,
        PRAGMA_DIR =    38 ,
        LINE_DIR =  37 ,
        ENDIF_DIR =     36 ,
        ELIF_DIR =  35 ,
        ELSE_DIR =  34 ,
        IF_DIR =    33 ,
        IFNDEF_DIR =    32 ,
        IFDEF_DIR =     31 ,
        INCLUDE_DIR =   30 ,
        OCTAL =     29 ,
        UOCTAL =    28 ,
        LOCTAL =    27 ,
        ULOCTAL =   26 ,
        HEXA =  25 ,
        UHEXA =     24 ,
        LHEXA =     23 ,
        ULHEXA =    22 ,
        INTEGER =   21 ,
        FLOAT =     20 ,
        UINTEGER =  19 ,
        LINTEGER =  18 ,
        ULINTEGER =     17 ,
        CHARACT =   16 ,
        STRING =    15 ,
        IDENT =     14 ,
        GOTO =  13 ,
        STR =   12 ,
        UNMARK =    11 ,
        MARK =  10 ,
        TAB_VIRT =  9 ,
        TAB =   8 ,
        NEWLINE =   7 ,
        ATTRIBUTS =     6 ,
        PLACE_HOLD_CONST
    } ; 
} ; 

extern metachop * parser_metachop;

#endif
#define NODE_LIST_metachop  332
#define NODE_TREE_metachop  331
#define SPACE_metachop  330
#define SEP_OMIT_metachop   329
#define SEP_BEFORE_metachop     328
#define SEP_AFTER_metachop  327
#define AFERAFER_metachop   326
#define ALINEA_metachop     325
#define CFERCFER_metachop   324
#define BOX_metachop    323
#define CHOP_DEF_metachop   322
#define NIL_metachop    321
#define IN_LANG_metachop    320
#define NEXT_metachop   319
#define DEF_IDENT_metachop  318
#define EXPO_metachop   317
#define EXPO_AFF_metachop   316
#define ETOIETOIEGAL_metachop   315
#define FOREACH_metachop    314
#define INFESEPOSUPE_metachop   313
#define INFESEPBSUPE_metachop   312
#define INFESEPASUPE_metachop   311
#define AOUVAOUV_metachop   310
#define COUVCOUV_metachop   309
#define ARRO_metachop   308
#define IN_metachop     307
#define PARSE_metachop  306
#define NEXTL_metachop  305
#define VALUE_metachop  304
#define INFESUPE_metachop   303
#define NL_BEG_metachop     302
#define TAB_BEG_metachop    301
#define SPACE_BEG_metachop  300
#define MAKETREE_SUP_metachop   299
#define MAKETREE_INF_metachop   298
#define PARSE_ELEM_metachop     297
#define SIMP_ETOI_metachop  296
#define ETOI_ETOI_metachop  295
#define BDECR_metachop  294
#define BINCR_metachop  293
#define ADDR_metachop   292
#define POINT_metachop  291
#define NOT_metachop    290
#define LNEG_metachop   289
#define POS_metachop    288
#define NEG_metachop    287
#define STRING_LIST_metachop    286
#define LABEL_metachop  285
#define ELSE_metachop   284
#define TUNSIGNED_metachop  283
#define TSIGNED_metachop    282
#define TIDENT_metachop     281
#define TFLOAT_metachop     280
#define TDOUBLE_metachop    279
#define RSHI_metachop   278
#define LSHI_metachop   277
#define LT_metachop     276
#define GT_metachop     275
#define GEQU_metachop   274
#define LEQU_metachop   273
#define PROTECT_MEMB_metachop   272
#define LANGUAGE_metachop   271
#define EXP_metachop    270
#define ADECR_metachop  269
#define AINCR_metachop  268
#define ARROW_metachop  267
#define REF_metachop    266
#define EXP_ARRAY_metachop  265
#define EXP_LIST_metachop   264
#define POIN_metachop   263
#define ARROW_MEMB_metachop     262
#define DOT_MEMB_metachop   261
#define POINETOI_metachop   260
#define PARAM_TYPE_metachop     259
#define TIRESUPEETOI_metachop   258
#define TIRESUPE_metachop   257
#define SUPESUPE_metachop   256
#define INFEINFE_metachop   255
#define SUPEEGAL_metachop   254
#define INFEEGAL_metachop   253
#define NEW_DECLARATOR_metachop     252
#define REM_metachop    251
#define DIV_metachop    250
#define MUL_metachop    249
#define POURC_metachop  248
#define MESSAGE_MAP_metachop    247
#define MACRO_metachop  246
#define TCHAR_metachop  245
#define TSHORT_metachop     244
#define TLONG_metachop  243
#define TINT_metachop   242
#define OR_metachop     241
#define VBARVBAR_metachop   240
#define AND_metachop    239
#define ETCOETCO_metachop   238
#define COMPOUND_EXT_metachop   237
#define EXTERNAL_metachop   236
#define INITIALIZER_metachop    235
#define LOR_metachop    234
#define VBAR_metachop   233
#define FUNC_metachop   232
#define STAT_VOID_metachop  231
#define TEMPLATE_DECL_metachop  230
#define SUPE_metachop   229
#define INFE_metachop   228
#define EXP_SEQ_metachop    227
#define LXOR_metachop   226
#define CHAP_metachop   225
#define EXCEPTION_metachop  224
#define NEQU_metachop   223
#define EQU_metachop    222
#define EXCLEGAL_metachop   221
#define EGALEGAL_metachop   220
#define PRAGMA_metachop     219
#define INDENT_FUNCTION_TYPE_metachop   218
#define COMMENT_PLUS_metachop   217
#define COMMENT_END_metachop    216
#define COMMENT_MIDDLE_metachop     215
#define COMMENT_START_metachop  214
#define MARGIN_VALUE_metachop   213
#define BRACE_ALIGN_VALUE_metachop  212
#define ASSIGN_ALIGN_metachop   211
#define SINGLE_SWITCH_INDENT_VALUE_metachop     210
#define SIMPLIFY_VALUE_metachop     209
#define SIMPLIFY_metachop   208
#define MODE_VALUE_metachop     207
#define TAB_VALUE_metachop  206
#define CONFIG_metachop     205
#define NO_PRETTY_metachop  204
#define ERROR_metachop  203
#define UNDEF_metachop  202
#define TYP_AFF_CALL_metachop   201
#define MEMBER_DECLARATOR_metachop  200
#define TYP_ARRAY_metachop  199
#define CFER_metachop   198
#define COUV_metachop   197
#define FOR_DECLARATION_metachop    196
#define DECLARATION_metachop    195
#define CTOR_INITIALIZER_metachop   194
#define CTOR_INIT_metachop  193
#define IUN_metachop    192
#define IUNLONG_metachop    191
#define ILONG_metachop  190
#define RANGE_MODIFIER_metachop     189
#define COND_AFF_metachop   188
#define INTE_metachop   187
#define COMPOUND_metachop   186
#define CLASS_DECL_metachop     185
#define AFER_metachop   184
#define CAST_metachop   183
#define DPOI_metachop   182
#define TYP_BIT_metachop    181
#define PROTECT_metachop    180
#define BASE_LIST_metachop  179
#define XOR_AFF_metachop    178
#define OR_AFF_metachop     177
#define AND_AFF_metachop    176
#define RSH_AFF_metachop    175
#define LSH_AFF_metachop    174
#define MIN_AFF_metachop    173
#define PLU_AFF_metachop    172
#define REM_AFF_metachop    171
#define DIV_AFF_metachop    170
#define MUL_AFF_metachop    169
#define AFF_metachop    168
#define POINPOINPOIN_metachop   167
#define VAR_LIST_metachop   166
#define TYP_LIST_metachop   165
#define TYP_AFF_metachop    164
#define ABST_DECLARATOR_metachop    163
#define DECLARATOR_metachop     162
#define LAND_metachop   161
#define INIT_NEW_metachop   160
#define VIRG_metachop   159
#define QUALIFIED_metachop  158
#define MINUS_metachop  157
#define TYP_metachop    156
#define PFER_metachop   155
#define DESTRUCT_metachop   154
#define TYP_REF_metachop    153
#define TYP_ADDR_metachop   152
#define DEFAULT_metachop    151
#define CASE_metachop   150
#define FORALLSONS_metachop     149
#define WHILE_metachop  148
#define SWITCH_metachop     147
#define RETURN_metachop     146
#define IF_metachop     145
#define FOR_metachop    144
#define DO_metachop     143
#define CONTINUE_metachop   142
#define BREAK_metachop  141
#define PVIR_metachop   140
#define TYPEDEF_metachop    139
#define TEMPLATE_metachop   138
#define EXTERN_metachop     137
#define STATIC_metachop     136
#define AUTO_metachop   135
#define AOUV_metachop   134
#define PUBLIC_metachop     133
#define PROTECTED_metachop  132
#define PRIVATE_metachop    131
#define CHAPEGAL_metachop   130
#define VBAREGAL_metachop   129
#define ETCOEGAL_metachop   128
#define SUPESUPEEGAL_metachop   127
#define INFEINFEEGAL_metachop   126
#define TIREEGAL_metachop   125
#define PLUSEGAL_metachop   124
#define POURCEGAL_metachop  123
#define ETOIEGAL_metachop   122
#define EGAL_metachop   121
#define ASM_metachop    120
#define CLASS_metachop  119
#define UNION_metachop  118
#define STRUCT_metachop     117
#define ENUM_metachop   116
#define CONST_metachop  115
#define FRIEND_metachop     114
#define VIRTUAL_metachop    113
#define INLINE_metachop     112
#define REGISTER_metachop   111
#define VOLATILE_metachop   110
#define SHORT_metachop  109
#define UNSIGNED_metachop   108
#define SIGNED_metachop     107
#define LONG_metachop   106
#define VOID_metachop   105
#define CHAR_metachop   104
#define INT_metachop    103
#define DOUBLE_metachop     102
#define VA_ARG_metachop     101
#define OPERATOR_metachop   100
#define DELETE_metachop     99
#define NEW_metachop    98
#define DPOIDPOI_metachop   97
#define SIZEOF_metachop     96
#define TIRETIRE_metachop   95
#define PLUSPLUS_metachop   94
#define ETCO_metachop   93
#define ETOI_metachop   92
#define EXCL_metachop   91
#define TILD_metachop   90
#define PLUS_metachop   89
#define TIRE_metachop   88
#define POUV_metachop   87
#define FUNC_SPEC_metachop  86
#define TRY_metachop    85
#define END_CATCH_metachop  84
#define END_CATCH_ALL_metachop  83
#define AND_CATCH_metachop  82
#define CATCH_metachop  81
#define CATCH_ALL_metachop  80
#define END_MESSAGE_MAP_metachop    79
#define BEGIN_MESSAGE_MAP_metachop  78
#define DECLARE_MESSAGE_MAP_metachop    77
#define IMPLEMENT_SERIAL_metachop   76
#define IMPLEMENT_DYNCREATE_metachop    75
#define IMPLEMENT_DYNAMIC_metachop  74
#define DECLARE_SERIAL_metachop     73
#define DECLARE_DYNAMIC_metachop    72
#define PUSH_FUNCTION_metachop  71
#define PUSH_ARGUMENT_metachop  70
#define UNDEF_CONTENT_metachop  69
#define SMALL_PRAGMA_CONTENT_metachop   68
#define PRAGMA_CONTENT_metachop     67
#define PRAGMA_INDENT_FUNCTION_TYPE_metachop    66
#define PRAGMA_COMMENT_PLUS_metachop    65
#define PRAGMA_COMMENT_END_metachop     64
#define PRAGMA_COMMENT_MIDDLE_metachop  63
#define PRAGMA_COMMENT_START_metachop   62
#define PRAGMA_MARGIN_metachop  61
#define PRAGMA_ASSIGN_ALIGN_metachop    60
#define PRAGMA_SINGLE_SWITCH_INDENT_metachop    59
#define PRAGMA_SIMPLIFY_metachop    58
#define PRAGMA_BRACE_ALIGN_metachop     57
#define PRAGMA_MODE_metachop    56
#define PRAGMA_RANGE_metachop   55
#define PRAGMA_TAB_metachop     54
#define PRAGMA_CONFIG_metachop  53
#define PRAGMA_NOPRETTY_metachop    52
#define PRAGMA_PRETTY_metachop  51
#define INCLUDE_LOCAL_metachop  50
#define INCLUDE_SYS_metachop    49
#define END_LINE_metachop   48
#define DEFINE_NAME_metachop    47
#define DEFINED_NOT_CONTINUED_metachop  46
#define DEFINED_CONTINUED_metachop  45
#define SLAS_metachop   44
#define SLASEGAL_metachop   43
#define CARRIAGE_RETURN_metachop    42
#define UNDEF_DIR_metachop  41
#define DEFINE_DIR_metachop     40
#define ERROR_DIR_metachop  39
#define PRAGMA_DIR_metachop     38
#define LINE_DIR_metachop   37
#define ENDIF_DIR_metachop  36
#define ELIF_DIR_metachop   35
#define ELSE_DIR_metachop   34
#define IF_DIR_metachop     33
#define IFNDEF_DIR_metachop     32
#define IFDEF_DIR_metachop  31
#define INCLUDE_DIR_metachop    30
#define OCTAL_metachop  29
#define UOCTAL_metachop     28
#define LOCTAL_metachop     27
#define ULOCTAL_metachop    26
#define HEXA_metachop   25
#define UHEXA_metachop  24
#define LHEXA_metachop  23
#define ULHEXA_metachop     22
#define INTEGER_metachop    21
#define FLOAT_metachop  20
#define UINTEGER_metachop   19
#define LINTEGER_metachop   18
#define ULINTEGER_metachop  17
#define CHARACT_metachop    16
#define STRING_metachop     15
#define IDENT_metachop  14
#define GOTO_metachop   13
#define STR_metachop    12
#define UNMARK_metachop     11
#define MARK_metachop   10
#define TAB_VIRT_metachop   9
#define TAB_metachop    8
#define NEWLINE_metachop    7
#define ATTRIBUTS_metachop  6
#undef _Tak
#define _Tak(func) func 
#endif
