language metalang ;

#include <token.h>
#include <metalang.h>
#include <metachop.h>

#define copytree CopyTree

/*****************************************************/
/* TreeAbstract : abstract the grammar	   		     */
/*****************************************************/

PTREE ListAdd(list,tree)
PTREE list ,tree;
{
	if ( tree) 
		list *= tree ;
	return list ;
}

PTREE TreeAbstract(tree)
PTREE tree;
{
	PTREE elem;
	PTREE list ;
	PTREE statement,condition,statement1,statement2,tree1,tree2 ;

	if ( !tree) return ();

	switch (tree) {
		case <MAKETREE,tree> :

			/* skip tree name */
			nextl(tree) ;

		case <LIST> :
			while (tree) {
				elem = nextl(tree);
				list = ListAdd(list,TreeAbstract(elem));
 			}
			break ;

		case <REPLACETREE,tree> :
			nextl(tree);
			nextl(tree);
			elem = nextl(tree);
			list = ListAdd(list,TreeAbstract(elem));
			break;
		case <ADDLIST> :
			nextl(tree);
			elem = nextl(tree);
			list = ListAdd(list,TreeAbstract(elem));
			break;
		case <NOT,tree> :
			list = ListAdd(list,<NOT,TreeAbstract(tree)>);
 			break;
 		case <COND,tree> :
			list = ListAdd(list,<COND,TreeAbstract(tree)>);
		case <EQUAL,<>,tree> :
		case <BEGIN,tree>:
			list = ListAdd(list,TreeAbstract(tree));
		case <RETURN,tree> : 
			list = ListAdd(list,tree);
			list = ListAdd(list,<RETURN,<IDENT,"OK">>);
			break; 
		case <OR,tree1,tree2> :
			list = ListAdd(list,<OR,TreeAbstract(tree1),TreeAbstract(tree2)>);
			break;
 		case <AND,tree1,tree2> :
 			list = ListAdd(list,<AND,TreeAbstract(tree1),TreeAbstract(tree2)>);
			break;	 
		case <CASE,tree> :
			{
				PTREE listCase ;	
				PTREE result ;
				while ( tree) {
					elem = nextl (tree) ;
					elem == <SWITCH,condition,statement> ;
					elem = <AND,TreeAbstract(condition),
											TreeAbstract(statement)>;
					listCase = elem * listCase ;
  				}
				
				while (listCase) {
					elem = nextl(listCase);
					if ( result != ()) {
						result = <OR,elem,result>;
					} else
						result = elem ;
				}
				list = ListAdd(list,result);
				break;
 			}
		case <BREAK> :
			ListAdd(list,<RETURN,<IDENT,"BAD">>);
			break;
 		case <TAKE,tree> :
			if ( tree == <EXCLA> && !strcmp(value(tree),"NOTHING"))
				list = ListAdd(list, <STRING,"_ALL_">);
			else
				list = ListAdd(list,copytree(tree));
			return 1 ;
		case <SEE> :
			{ 
 			if ( tree == <SEE,<EXCLA>> && !strcmp(value(tree),"NOTHING"))
				break;
			else
				list = ListAdd(list,copytree(tree)) ;
  			return 1 ;
			}
		case <REPEAT,statement,condition> :
			list = ListAdd(list,<AND,<WHILE,TreeAbstract(statement)>,
						TreeAbstract(condition)>);
			break;
 		case <IF,condition,statement1,statement2> : 
			list = ListAdd(list,
						<OR,<AND,TreeAbstract(condition),
									TreeAbstract(statement1)>,
									TreeAbstract(statement2)>);
			break;
 		case <WHILE,condition,statement> :
			list = ListAdd(list,
				<WHILE,<AND,TreeAbstract(condition),TreeAbstract(statement)>>);
			break;
  		case <ASIT> :
		case <SKIP> :
		case <TAKEL> : 
		case <SEEL> : 
		case <STOREL> : 
		case <RESETL> :
		case <FORGETL> : 
		case <RECOVERL> :
		case <FORGET> :
		case <RECOGNIZE_STRING> :
			/* something too complex to do anything */
			list = ListAdd(list,<STRING,"?">);
 		default : 
			break;
 	}
	return list ;
}

/*********************************************************/
/* Treatment : treatment of whole tree					 */
/*********************************************************/

int nbRule = 0 ;

Treatment(tree)
PTREE tree ;
{
	PTREE name,patternRec,list,listFunc,elem ;

	/* compute the tokens for each function */
	listFunc ;
	foreach ((),tree,{
		if ( for_elem == <DEFINE,name,patternRec>) {
			list = TreeAbstract(patternRec);
 			listFunc *= <LIST,<LIST,copytree(name),()>,list>;
 		}
	})
 
 	DumpTree(listFunc);
}

